<?php

//
// action.inc
//
//
//  This file contains code which is used for the following actions:
//
//   * start
//   * stop
//   * pause
//   * unpause
//   * shutdown
//
//  This is common code.
//



//
//  Perform a login operation.  If successful return 1.
// otherwise return 0.
//
//
//  Parameters:
//    $fp - Open socket.
//
function doLogin( $fp )
{
   $host     = $_SESSION["hostname"];
   $port     = $_SESSION["port"];
   $password = $_SESSION["password"];
   $username = $_SESSION["username"];

   // send the authentication request.
   fputs ($fp, "auth $username $password\n");
	    
   // loop reading until we get either 300 / 400.
   $run = 1;
   while( $run )
   {
      $result = fgets($fp, 100);

      if ( substr($result, 0, 3) == "200" )
      {
         $run = 1;
      }
      else if ( substr($result, 0, 3) == "300" )
      {
         $run	 = 0;
         $result = 1;
      }
      else if ( substr($result, 0, 3) == "400" )
      {
         $run	 = 0;
         $result = 0;
      }
   }
   return( $result );
}




//
//  Send an operation to the server, if successful return "".
//
//  Otherwise return an error string.
//
//  Parameters:
//    $action - The text action to perform.
//
function doAction( $action )
{
   $host     = $_SESSION["hostname"];
   $port     = $_SESSION["port"];
   $password = $_SESSION["password"];
   $username = $_SESSION["username"];

   //
   // open a client connection
   //
   $fp = fsockopen ($host, $port, $errno, $errstr);
   if (!$fp)
   {
       return("Error: could not open socket connection $host:$port\n");
   }

   //
   // Do the login. 
   //
   if ( !doLogin( $fp ) )
   {
      return( "login failed" );
   }

   //
   // Now send the request.
   fputs ($fp, "$action\n" );

   //
   // loop reading until we get either 300 / 400.
   //
   $run	   = 1;
   $result = "";

   while( $run )
   {
      $temp = fgets($fp, 100);

      if ( substr($temp, 0, 3) == "200" )
      {
         $run	 = 1;
	 $result = "";
      }
      else if ( substr($temp, 0, 3) == "300" )
      {
         $run	 = 0;
      }
      else if ( substr($result, 0, 3) == "400" )
      {
         $run	 = 0;
         $temp = substr( $result, 3 );
      }
      else
      {
         $result = $result . $temp;
      }
   }

   //
   // Close the socket.
   //
   fclose( $fp );

   return( $result );

}


//
//  Return our version number.
//
function getArgoVersion()
{
   return( "0.6" );
}

?>